﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Threading;
using _4sightweb;

public partial class _Default : System.Web.UI.Page 
{

  private List<Control> controls = new List<Control>();
  protected void Page_PreInit ( object sender, EventArgs e )
  {
    LoadControls();
  }

  private void LoadControls ()
  {
    RunParameterControl ctlRun = ( RunParameterControl ) Page.LoadControl( "~/RunParameterControl.ascx" );
    ctlRun.ID = "Runs";

    controls.Add( ctlRun );

    for( int i = 0; i < 19; ++i )
    {
      MVWebDropdown ctlMVDropdown = ( MVWebDropdown ) Page.LoadControl( "~/MVWebDropdown.ascx" );     
      ctlMVDropdown.ID = "Control" + i.ToString();
      controls.Add( ctlMVDropdown );
    }

  }

  private Dictionary<string, string> GetData ()
  {
    Dictionary<string, string> data = new Dictionary<string, string>();

    for( int i = 0; i < 20; ++i )
      data.Add( "Item " + i.ToString(), i.ToString() );

    return data;

  }
  protected void Page_Load ( object sender, EventArgs e )
    {
      if( !IsPostBack )
      {
        PopulateControls();
      }
    }

    private void PopulateControls ()
    {
      Dictionary<string, string> data = GetData();

      ( ( RunParameterControl ) controls [0] ).LoadDropDowns( 0, DateTime.Now );

      for( int i = 1; i < 20; ++i )
        ( ( MVWebDropdown ) controls [i] ).LoadDropdown( data );


      for( int i = 0; i < 20; ++i )
      {
        ParamPanel.Controls.Add( controls [i] );
        ParamPanel.Controls.Add( new LiteralControl( "<br  />" ) );
      }
     
    }

    protected void btnRunReport_Click ( object sender, EventArgs e )
    {
      try
      {
        Thread.Sleep( 5000 ); // simulate generating report file.

        if( reportFrame.Attributes["src"] == "voicemailquickie.pdf" )
          reportFrame.Attributes.Add( "src", "flexform.pdf");
        else
          reportFrame.Attributes.Add( "src", "voicemailquickie.pdf" );
      }
      catch( Exception ex )
      {
        // throw something.
      }
    }
}
