﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.ListControls;
using System.Data.Common;

namespace _4sightweb
{
  public partial class RunParameterControl : System.Web.UI.UserControl
  {
   
    public string Value
    {
      get
      {
        string str = "";

        foreach( DropDownItem ddi in ctlRuns.SelectedItems )
          str += ddi.Value;

        return str;
      }
    }
       
    //****************************************************************************************************
    //  Method Name:	Page_Load
    /// <summary>             	Description:	Summary of Page_Load().</summary>
    /// <param name="sender"> 	Parameter:		sender	Type:	object</param>
    /// <param name="e">      	Parameter:		e     	Type:	System.EventArgs</param>
    //****************************************************************************************************
    protected void Page_Load ( object sender, EventArgs e )
    {
      string strRunsId = this.ctlRuns.ClientID;
      string strClearAll = "javascript:" + strRunsId + "_ClearAll();";
      string strSelectAll = "javascript:" + strRunsId + "_SelectAll();";

      this.ctlClearAll.Attributes.Add( "href", strClearAll );
      this.ctlSelectAll.Attributes.Add( "href", strSelectAll );

      RegisterClientScript();
    }
    //****************************************************************************************************
    //  Method Name:	LoadDropDowns
    /// <summary>               	Description:	Summary of LoadDropDowns().</summary>
    /// <param name="Inst">     	Parameter:		Inst    	Type:	int</param>
    /// <param name="ProcDate"> 	Parameter:		ProcDate	Type:	System.DateTime</param>
    //****************************************************************************************************
    public void LoadDropDowns ( int Inst, DateTime ProcDate )
    {
      ctlInst.Value = Inst.ToString();
      ctlProcDate.Value = ProcDate.ToString();

      LoadOrderBy();
      LoadRuns();
    }
    //****************************************************************************************************
    //  Method Name:	LoadOrderBy
    /// <summary> 	Description:	Summary of LoadOrderBy().</summary>
    //****************************************************************************************************
    private void LoadOrderBy ()
    {
      
      try
      {       

        for (int i = 0; i < 3; ++i)
        {
          DropDownItem ddi = new DropDownItem("Item " + i.ToString(), i.ToString() );
          this.ctlOrderRuns.Items.Add( ddi );
        }

        ctlOrderRuns.Items [0].Selected = true;
        ctlOrderRuns.SelectedItemIndex = 0;
      }
      catch( Exception ex )
      {
        throw new Exception( "Error loading Runs: " + ex.Message );
      }      
    }
    //****************************************************************************************************
    //  Method Name:	LoadDropDown
    /// <summary>                    	Description:	Summary of LoadDropDown().</summary>
    /// <param name="strConnection"> 	Parameter:		strConnection	Type:	string</param>
    //****************************************************************************************************
    private void LoadRuns ()
    {

      try
      {
        ctlRuns.Items.Clear();

        for (int i = 0; i < 50; ++i)
        {
          DropDownItem ddi = new DropDownItem( "Run " + i.ToString(), i.ToString() );
          ddi.Selected = true;
          this.ctlRuns.Items.Add( ddi );
        }

        ctlRuns.CurrentValue = "All";
      }
      catch( Exception ex )
      {
        throw new Exception( "Error loading Runs: " + ex.Message );
      }      
    }
    //****************************************************************************************************
    //  Method Name:	RegisterClientScript
    /// <summary> 	Description:	Summary of RegisterClientScript().</summary>
    //****************************************************************************************************
    private void RegisterClientScript ()
    {
      string strRunsId = this.ctlRuns.ClientID;

      if( !Page.ClientScript.IsClientScriptBlockRegistered( strRunsId ) )
      {

        string scriptBlock = "function " + strRunsId + "_ClearAll()" + "{ " +
            "var dropDown = $find('" + strRunsId + "'); " +
                "var len = dropDown.get_items().get_length(); " +
                "for (var i = 0; i < len; i++) { " +
                "  var item = dropDown.get_items().getItem(i); " +
                "  if (item != null) { " +
                "    item.get_element().childNodes[0].checked = false; " +
                "    item.unselect(); " +
                "  } " +
                "} " +
                "dropDown.set_currentValue('',true); } ";

        scriptBlock += "function " + strRunsId + "_SelectAll()" + "{ " +
            "var dropDown = $find('" + strRunsId + "'); " +
                "var len = dropDown.get_items().get_length(); " +
                "for (var i = 0; i < len; i++) { " +
                "  var item = dropDown.get_items().getItem(i); " +
                "  if (item != null) { " +
                "    item.select(); " +
                "    item.get_element().childNodes[0].checked = true; " +
                "  } " +
                "} " +
                "dropDown.set_currentValue('All',true); }";

        scriptBlock += "function " + this.ID + "_Toggle(){" +
                        " var control = $find('" + this.ID + "_ctlOrderRuns');" +
                        " var value =  control.get_enabled() == true ? false: true;" +
                        " control.set_enabled(value);" +
                        " $find('" + this.ID + "_ctlIncludeNonExported').set_enabled(value);" +
                        " $find('" + this.ID + "_ctlRuns').set_enabled(value);}";

        Page.ClientScript.RegisterClientScriptBlock( this.Page.GetType(), strRunsId, scriptBlock, true );
      }
    }


    //****************************************************************************************************
    //  Method Name:	ctlOrderRuns_SelectionChanged1
    /// <summary>             	Description:	Summary of ctlOrderRuns_SelectionChanged1().</summary>
    /// <param name="sender"> 	Parameter:		sender	Type:	object</param>
    /// <param name="e">      	Parameter:		e     	Type:	Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs</param>
    //****************************************************************************************************
    protected void ctlOrderRuns_SelectionChanged1 ( object sender, DropDownSelectionChangedEventArgs e )
    {
      LoadRuns();
    }

    //****************************************************************************************************
    //  Method Name:	ctlIncludeNonExported_SelectionChanged1
    /// <summary>             	Description:	Summary of ctlIncludeNonExported_SelectionChanged1().</summary>
    /// <param name="sender"> 	Parameter:		sender	Type:	object</param>
    /// <param name="e">      	Parameter:		e     	Type:	Infragistics.Web.UI.ListControls.DropDownSelectionChangedEventArgs</param>
    //****************************************************************************************************
    protected void ctlIncludeNonExported_SelectionChanged1 ( object sender, DropDownSelectionChangedEventArgs e )
    {
      LoadRuns();
    }
  }
}
